
package de.ivu.elect.presentation.gruppeimgebiet;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.gruppeimgebiet.boundary.GruppeImGebietConversationStore;
import de.ivu.elect.business.gruppeimgebiet.boundary.GruppeImGebietExtendedDAO;
import de.ivu.elect.business.gruppeimgebiet.boundary.GruppeImGebietEdit;
import de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet;
import de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractGruppeImGebietEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractGruppeImGebietEditNoScopeView.VIEW_ID, useCase = UseCasePermission.GRUPPE_IM_GEBIET_EDIT)
public abstract class AbstractGruppeImGebietEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<GruppeImGebiet>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gruppeImGebietEditView";

  public static final String VIEW_ID = "/gruppeimgebiet/gruppe-im-gebiet-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/gruppeimgebiet/gruppe-im-gebiet-search.xhtml";

  @Inject
  protected transient GruppeImGebietExtendedDAO extendedDAO;

  @Inject
  protected transient GruppeImGebietEdit edit;

  @Inject
  @ConversationGroup(GruppeImGebietConversationStore.class)
  protected transient GruppeImGebietConversationStore conversationStore;

  @Inject
  protected transient GruppeImGebietMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient GruppeImGebietEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public GruppeImGebiet getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(GruppeImGebiet entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.GRUPPE_IM_GEBIET_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(GruppeImGebiet entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.GRUPPE_IM_GEBIET_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.GRUPPE_IM_GEBIET_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.GRUPPE_IM_GEBIET_EDIT)
  @Override
  public String save() {
    GruppeImGebiet entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(GruppeImGebiet entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    GruppeImGebiet entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(GruppeImGebiet entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.GRUPPE_IM_GEBIET_EDIT);
  }
  
  @Redirect
  public String edit(GruppeImGebiet entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class GruppeImGebietEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<GruppeImGebiet,   de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietPK  > {

    private static final long serialVersionUID = 1L;
  }
}
